import os
import shutil
from datetime import datetime


# Alle Funktionen die das os Modul zur Verfügung stellt
print(dir(os))

# Datei Operationen
# Datei öffnen um zu schreiben
textDatei = open("NeueTextdatei.txt", "w")
textDatei.write("Hallo Welt =)")
textDatei.close()

textDatei = open("NeueTextdatei.txt", "w")  # überschreibt existierende Datei
textDatei.write("Hallo Welt =)")
textDatei.close()

textDatei = open("NeueTextdatei.txt", "a")  # fügt etwas zu existierender Datei hinzu
textDatei.write("Noch mal Hallo Welt =)")
textDatei.close()

# Datei auslesen
textDatei = open("NeueTextdatei.txt", "r")
print(textDatei.readlines())
textDatei.close()

# Dateigröße und Änderungszeitpunkt auslesen
print(os.stat("NeueTextdatei.txt").st_size)
print(datetime.fromtimestamp(os.stat("NeueTextdatei.txt").st_mtime))

# Datei mit Matadaten kopieren
shutil.copy2("NeueTextdatei.txt", "NeueTextdatei2.txt")

# Datei löschen
os.remove("NeueTextdatei.txt")
os.remove("NeueTextdatei2.txt")


# Verzeichnis Operationen
# Aktuelles Ausführungsverzeichnis abfragen
print(os.getcwd())

# Inhalt eines Verzeichnis abfragen
print(os.listdir())
print(os.listdir(r"C:\Windows"))

# Slash - URIs und Pfade von Unix Betriebssystemen
# Backslash - Escape Zeichen (\n, \t, ...) und Pfade von Windows Betriebssystemen
# "C:\\Users\\peter\\Documents\\file.txt"
# r"C:\Users\peter\Documents\file.txt"

# Neues Verzeichnis erstellen
os.mkdir("NeuerOrdner")
os.makedirs(r"NeuerOrdner2\NeuerUnterordner")

# Verzeichnis umbenennen
os.rename("NeuerOrdner", "UmbenannterOrdner")

# Verzeichnis löschen
os.rmdir("UmbenannterOrdner")   # löscht leere Ordner
shutil.rmtree("NeuerOrdner2")   # löscht Ordner und alle Unterelemente

# Verzeichnisbaum ablaufen
for pfad, unterordner, dateien in os.walk(os.getcwd()):
    for datei in dateien:
        print(datei)


# Pfad Operationen
verzeichnis = os.getcwd()
dateiName = "NeueTextdatei2.txt"

# Verzeichnisgröße abfragen
print(os.path.getsize(verzeichnis))

# Verzeichnis und Dateiname zusammensetzen
dateiPfad = os.path.join(verzeichnis, dateiName)
print(dateiPfad)

# Dateinamen auslesen
print(os.path.basename(dateiPfad))

# Verzeichnis auslesen
print(os.path.dirname(dateiPfad))

# Prüfen ob Verzeichnis oder Datei existiert
print(os.path.exists(dateiPfad))

# Verzeichnis und Dateinamen trennen
print(os.path.split(dateiPfad))
