import logging
import LoggingMitLoggerObjekt


# Einfaches logging mit logging Modul
logging.basicConfig(filename="LogFileName.log", level=logging.INFO, format="%(asctime)s; %(levelname)s; %(message)s")

logging.debug("Debug logging ...")
logging.info("Info logging ...")
logging.warning("Warning logging ...")
logging.error("Error logging ....")
logging.critical("Exception logging ...")


# Logging mit logging Objekt
def GetLogger():
	"""Neuen Logger erstellen."""
	logger = logging.getLogger("LoggerName")
	logger.setLevel(logging.INFO)
	fileHandler = logging.FileHandler(filename="LogFileName.log")
	formatter = logging.Formatter("%(asctime)s; %(name)s; %(levelname)s; %(message)s")
	fileHandler.setFormatter(formatter)
	logger.addHandler(fileHandler)

	return logger


# logger Objekt erstellen
logger = GetLogger()

logger.info("Info logging mit logger Objekt ...")
LoggingMitLoggerObjekt.FunktionInEinemAnderenModul(logger)
