# numpy - Numerical Python

# Installation
# pip install numpy

# Importieren
import numpy as np

# ndarray
numpyArray = np.array([0, 1, 2, 3, 4, 5])
print(numpyArray)
numpyArray2 = np.arange(6)
print(numpyArray2)
print(type(numpyArray))


# Dimensionen und Formen
# 0d Array - Scalar
scalar = np.array(21)
print(scalar)
print(scalar.ndim)
print(scalar.shape)

# 1d Array - Liste / Vektor
liste = np.array([0, 1, 2, 3])
print(liste)
print(liste.ndim)
print(liste.shape)

# 2d Array - Matrix / Tabelle
matrix = np.array([[0, 1], 
				   [2, 3], 
				   [4, 5]])
print(matrix)
print(matrix.ndim)
print(matrix.shape)

# 3d Array - Tensor
tensor = np.array([[[255, 255, 255], [0, 0, 0]],
				  [[0, 0, 0], [255, 255, 255]]])
print(tensor)
print(tensor.ndim)
print(tensor.shape)


# Auf Elemente zugreifen
print(liste[1])
print(matrix[1][0])
print(tensor[1][1])


# Arithmetische Berechnungen
# Werden für jedes Element des Arrays durchgeführt
print(numpyArray)
print(numpyArray + numpyArray2)
print(numpyArray ** 2)
print(numpyArray < 2)

# Array Berechnungen
matrixA = np.array([[1, 1], 
					[0, 1]])
matrixB = np.array([[2, 0], 
					[3, 4]])
print(matrixA * matrixB)	# Elementweises Produkt

# Matrix Produkt
print(matrixA.dot(matrixB))

# Umformen von Arrays
print(matrix)
flachesArray = matrix.ravel()	# .reshape(-1)
print(flachesArray)

transponiertesArray = matrix.T
print(transponiertesArray)

neuesArray = matrix.reshape(2, 3)	# gibt neues Array mit modifizierter Form zurück
print(neuesArray)
matrix.resize(2, 3)					# passt Form des Arrays selbst an
print(matrix)


# Zusammensetzen
print(np.vstack((matrixA, matrixB)))	# row_stacks für 2d Arrays
print(np.hstack((matrixA, matrixB)))	# column_stacks für 2d Arrays


# Iterieren
for i in matrix:
	print(i)

for i in matrix:
	for k in i:
		print(k)


# Abfragen
print(numpyArray)
print(np.any(numpyArray > 3))
print(np.all(numpyArray > 3))
print(np.where(numpyArray * 2 > 3))
