import warnings
warnings.simplefilter(action='ignore', category=FutureWarning)

# pandas - Datenanalyse und -manipulation

# Installation
# pip install pandas

# Importieren
import pandas as pd
import numpy as np


# Daten laden und anschauen
# Aus Python Objekten
matrix = np.array([[0, 1], [1, 1], [2, 2], [3, 3], [4, 5], [5, 8], [6, 13], [7, 21], [8, 34], [9, 55]])
pythonDaten = pd.DataFrame(matrix)
print(type(pythonDaten))
print(pythonDaten.shape)
print(pythonDaten.head())
print(pythonDaten.tail())

# Aus .csv Dateien
csvDaten = pd.read_csv(r"Daten\bp-stats-review-2020-all-data.csv", sep=";")
print(type(csvDaten))
print(csvDaten.shape)
print(csvDaten.head())
print(csvDaten.tail())
print(csvDaten.columns)


# Daten aufbereiten
# NaN Spalten löschen
nanSpaltenGeloescht = csvDaten.dropna(axis="columns", how="all")
print(nanSpaltenGeloescht.head())

# ^ mit 0 ersetzen
werteErsetzt = nanSpaltenGeloescht.replace("^", 0)
print(werteErsetzt.head())

# Daten auswählen
laender = nanSpaltenGeloescht["Thousand tonnes of Lithium content"]
print(type(laender))
print(laender.head())

laender2019 = nanSpaltenGeloescht[["Thousand tonnes of Lithium content", "2019"]]
print(type(laender2019))
print(laender2019.head())


# Daten filtern und ordnen
# Länder mit weniger als 1000 t Förderung ausschließen
mehrAls1kt = laender2019[laender2019["2019"] > 1]
print(type(mehrAls1kt))
print(mehrAls1kt.head())

# Nach geförderter Masse absteigend sortieren
sortiert = mehrAls1kt.sort_values(by=["2019"], ascending=False)
print(sortiert.head())


# Data Frame speichern
sortiert.to_excel(r"Daten\LithiumFoerderung2019.xlsx")  # pip install openpyxl
sortiert.to_csv(r"Daten\LithiumFoerderung2019.csv")
