# Scope - Globale und Lokale Variablen

# Variablen sind nur in dem Bereich (Scope) verfügbar in dem sie erstellt wurden.
def ScopeTest():
    lokaleVariable = "lokale Variable"
    print(globaleVariable)
    print(lokaleVariable)    


globaleVariable = "globale Variable"

ScopeTest()
print(globaleVariable)
#print(lokaleVariable)


# Wenn du Variable mit gleichem Namen innerhalb und außerhalb einer Funktion nutzt, erstellt Python automatisch zwei verschiedene Variablen.
def ScopeTest2():
    globaleVariable = "lokale Variable mit gleichem Namen"
    lokaleVariable = "lokale Variable"
    print(globaleVariable)
    print(lokaleVariable)    


globaleVariable = "globale Variable"
print(globaleVariable)

ScopeTest2()

print(globaleVariable)


# Um globale Variablen zu ändern solltest du am besten mit Rückgabewerten arbeiten.
def ScopeTest3():    
    return "geänderte globale Variable"


globaleVariable = "globale Variable"
print(globaleVariable)

globaleVariable = ScopeTest3()

print(globaleVariable)


# (alternativ kannst du mit dem Schlüsselwort "global" explizit auf die globale Variable zugreifen)
def ScopeTest4():
    global globaleVariable 
    globaleVariable = "geänderte globale Variable"
    print(globaleVariable) 


globaleVariable = "globale Variable"
print(globaleVariable)

ScopeTest4()

print(globaleVariable)
